#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const yargs_1 = __importDefault(require("yargs/yargs"));
const helpers_1 = require("yargs/helpers");
const _1 = require("./");
const path_1 = __importDefault(require("path"));
const boxen_1 = __importDefault(require("boxen"));
const safe_1 = __importDefault(require("colors/safe"));
const res = yargs_1.default(helpers_1.hideBin(process.argv))
    .option("packsDirectory", {
    alias: "d",
    type: "string",
    demandOption: true,
    description: "Directory",
})
    .strict()
    .option("port", {
    alias: "p",
    type: "number",
    default: 4000,
    description: "Port",
})
    .option("config", {
    alias: "c",
    type: "string",
    default: "webpack.config.js",
    description: "Webpack config",
})
    .help().argv;
let entryList;
_1.createServer({
    packsDirectory: res.packsDirectory,
    host: `http://localhost:${res.port}`,
    config: require(path_1.default.join(process.cwd(), res.config)),
    configure: list => {
        entryList = list;
    }
}).then((app) => app.listen(res.port, () => {
    const msgs = [];
    const link = `http://localhost:${res.port}`;
    msgs.push(`Server:      ${safe_1.default.green(link)}`);
    msgs.push(`Admin panel: ${safe_1.default.green(link + "/admin")}`);
    msgs.push(`\nAvailable entries:\n`);
    entryList.entries.forEach(entry => {
        msgs.push('- ' + safe_1.default.green(link + entry.url));
    });
    const message = boxen_1.default(msgs.join("\n"), { padding: 1 });
    console.log(message);
}));
//# sourceMappingURL=cli.js.map